package com.example.parkingcapstone;

import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.util.Log;
import android.widget.Toast;

public class DataManager {
    public static final String MYAPP = "CAPSTONE";
    private SQLiteDatabase db;
    public static final String TABLE_ROW_LOT= "lot";
    public static final String TABLE_ROW_SPOT = "spot";
    public static final String TABLE_ROW_PLATE = "plate";
    public static final String TABLE_ROW_START = "start";
    public static final String TABLE_ROW_END = "endTime";
    public static final String DB_NAME = "parking_db";
    public static final int DB_VERSION = 1;
    public static final String TABLE_PARK = "lot_spot_plate_time";

    public DataManager (Context context) {
        CustomSQLiteOpenHelper helper = new CustomSQLiteOpenHelper(context);
        db = helper.getWritableDatabase();
    }

    /*
    public void Insert(Player a) {
        String name2 = a.getName();
        int score = a.getScore();
        String query = "INSERT INTO " + TABLE_PLAYERS  + " (" +
                TABLE_ROW_NAME + ", " + TABLE_ROW_SCORE  + ") " +
                "VALUES (" + "'" + name2 +  "'" + ", " +
                score +    ");";

        Log.i("MYAPP",   query);
        db.execSQL(query);
    }

     */
    public void Insert(Car p){
        int lot = p.lot;
        int spot = p.spot;
        String plate = p.plate;
        long start = p.timeStart;
        long tEnd = p.timeEnd;

        String query = "INSERT INTO " + TABLE_PARK + " (" + TABLE_ROW_LOT + ", "
                + TABLE_ROW_SPOT + ", " + TABLE_ROW_PLATE + ", " + TABLE_ROW_START
                + ", " + TABLE_ROW_END +") " + "VALUES (" + lot + ", " + spot + ", " + "'" + plate + "'"
                + ", " + start + ", " + tEnd + ");";

        Log.i("MYAPP", query);
        db.execSQL(query);
    }

    public int countSpots(int lot)
    {
        int total = 0;
        String query = "SELECT COUNT(*) FROM " + TABLE_PARK + " WHERE " + TABLE_ROW_LOT + "=" + lot;
        Cursor c = db.rawQuery(query, null);
        if (c != null && c.moveToFirst()) {
            // do your stuff
            total = c.getInt(0);

        }
        Log.i("count", total+"");
        return total;
    }

    public Cursor whichSpots(int lot) {
        String query = "SELECT * FROM " + TABLE_PARK + " WHERE " + TABLE_ROW_LOT + "=" + lot;
        Cursor c = db.rawQuery(query, null);
        return c;
    }

    public long getTimeRemaining(Car c)
    {
        long remaining;
        String plate = c.plate;
        String query = "SELECT * FROM " + TABLE_PARK + " WHERE " + TABLE_ROW_PLATE + "=" + "'" + plate + "'";
        Cursor q = db.rawQuery(query, null);
       q.moveToNext();
        remaining = q.getLong(4);
        return remaining;


    }


    private class CustomSQLiteOpenHelper extends SQLiteOpenHelper {
        public CustomSQLiteOpenHelper(Context context){
            super(context, DB_NAME, null, DB_VERSION);
        }
        @Override
        public void onCreate(SQLiteDatabase db) {
            String newTableQueryString = "create table "
                    + TABLE_PARK  + " ("
                    + TABLE_ROW_LOT
                    + " integer not null,"
                    + TABLE_ROW_SPOT
                    + " integer not null,"
                    + TABLE_ROW_PLATE
                    + " String not null,"
                    + TABLE_ROW_START
                    + " long not null,"
                    + TABLE_ROW_END
                    + " long not null);" ;
            db.execSQL(newTableQueryString);
        }
        @Override
        public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {

        }
    }
}
