package com.example.parkingcapstone;

import androidx.appcompat.app.AppCompatActivity;

import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.EditText;
import android.widget.Toast;

import org.json.JSONArray;
import org.json.JSONException;

import java.io.IOException;
import java.util.Calendar;
import java.util.concurrent.TimeUnit;

import okhttp3.Call;
import okhttp3.Callback;
import okhttp3.FormBody;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.RequestBody;
import okhttp3.Response;

public class EnterTime extends AppCompatActivity {

    int jnum;
    JSONArray json;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_enter_time);

        //Request info from database, this is in preparation for the next activity
        String url = "http://compsci02.snc.edu/cs460/2020/cadont/capstone/read_from_db.php";
        OkHttpClient client = new OkHttpClient();

        Request request = new Request.Builder()
                .url(url)
                .build();

        client.newCall(request).enqueue(new Callback() { // asynchronous, otherwise won't run
            @Override
            public void onFailure(Call call, IOException e) {
                e.printStackTrace();
            }

            @Override
            public void onResponse(Call call, Response response) throws IOException {
                String myResponse = response.body().string(); // get what PHP echoed

                try {
                    json = new JSONArray(myResponse); // get JSONArray out of it
                    jnum = json.length();
                } catch (JSONException e) {
                } // try catch
                MainActivity.mainJson = json;
                MainActivity.mainJnum = jnum;
            } // onResponse
        });
        //End PHP request
    }

    public void toPay(View v) // onClick
    {
        EditText etPlt = (EditText)findViewById(R.id.etPlate);
        MainActivity.c.plate = etPlt.getText().toString();

        Calendar calendar = Calendar.getInstance();
        EditText etTm = (EditText)findViewById(R.id.etTime);



        String plate = etPlt.getText().toString();
        String mins = etTm.getText().toString();


        if(plate.isEmpty() || mins.isEmpty())
            Toast.makeText(this, "ERROR: Cannot process information", Toast.LENGTH_SHORT).show();

        else if (Integer.parseInt(mins) > 240)
            Toast.makeText(this, "ERROR: Requested time exceeds 4 hours", Toast.LENGTH_SHORT).show();

        else {
            //Get minutes user is requesting
            int minutes = Integer.parseInt(etTm.getText().toString());

            // Calculate price
            MainActivity.price = minutes / 15;
            if (MainActivity.price == 0)
                MainActivity.price = 1;

            //Get start time (in milliseconds)
            long start = calendar.getTimeInMillis();
            MainActivity.c.timeStart = start;

            //Convert requested minutes to milliseconds and calculate end time
            long addTime = TimeUnit.MINUTES.toMillis(minutes);
            MainActivity.c.timeEnd = start + addTime;

            Intent intent = new Intent(this, WhichLots.class);
            startActivity(intent);
            this.finish();
        }
    }
}
