package com.example.parkingcapstone;

import androidx.appcompat.app.AppCompatActivity;

import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.EditText;
import android.widget.Toast;

import org.json.JSONArray;
import org.json.JSONException;

import java.io.IOException;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.concurrent.TimeUnit;

import okhttp3.Call;
import okhttp3.Callback;
import okhttp3.FormBody;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.RequestBody;
import okhttp3.Response;

public class GetDate extends AppCompatActivity {

    int jnum;
    JSONArray json;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_get_date);

        //Same thing as EnterTime.java, preparing information from the database, storing it into JSON Array
        //Thank you Joseph
        String url = "http://compsci02.snc.edu/cs460/2020/cadont/capstone/read_from_db.php";
        OkHttpClient client = new OkHttpClient();

        Request request = new Request.Builder()
                .url(url)
                .build();

        client.newCall(request).enqueue(new Callback() { // asynchronous, otherwise won't run
            @Override
            public void onFailure(Call call, IOException e) {
                e.printStackTrace();
            }

            @Override
            public void onResponse(Call call, Response response) throws IOException {
                String myResponse = response.body().string(); // get what PHP echoed

                try {
                    json = new JSONArray(myResponse); // get JSONArray out of it
                    jnum = json.length();
                } catch (JSONException e) {
                } // try catch

                MainActivity.mainJson = json;
                MainActivity.mainJnum = jnum;
            } // onResponse
        });
    }

    public void reserve(View v)
    {
        //Format all data so that it can be put into the database

        EditText plate = (EditText)findViewById(R.id.etPl8);
        EditText date = (EditText)findViewById(R.id.etDate);
        EditText time = (EditText)findViewById(R.id.etTimeNecessary);
        MainActivity.c.plate = plate.getText().toString();



        String sDate = date.getText().toString();
        DateFormat df = new SimpleDateFormat("MM/dd/yyyy HH:mm");
        Calendar calendar  = Calendar.getInstance();
        try {
            calendar.setTime(df.parse(sDate));
        }
        catch (java.text.ParseException e) {
            Log.i("date", e.toString());
        }

        String p = plate.getText().toString();
        String d = date.getText().toString();
        String t = time.getText().toString();

        if(p.isEmpty() || d.isEmpty() || t.isEmpty())
            Toast.makeText(this, "ERROR: Cannot process information", Toast.LENGTH_SHORT).show();

        else if (Integer.parseInt(t) >240)
            Toast.makeText(this, "ERROR: Requested time exceeds 4 hours", Toast.LENGTH_SHORT).show();

        else {

            //Get minutes user is requesting
            int minutes = Integer.parseInt(time.getText().toString());

            MainActivity.price = minutes / 15;
            if (MainActivity.price == 0)
                MainActivity.price = 1;

            //Get start time (in milliseconds)
            long start = calendar.getTimeInMillis();
            MainActivity.c.timeStart = start;

            //Convert minutes to milliseconds and calculate end time
            long addTime = TimeUnit.MINUTES.toMillis(minutes);
            MainActivity.c.timeEnd = start + addTime;


            Intent intent = new Intent(this, Res_WhichLot.class);
            startActivity(intent);
            this.finish();
        }
    }
}
