package com.example.parkingcapstone;


import android.os.Bundle;
import android.text.Editable;
import android.text.TextWatcher;
import android.util.Log;
import android.view.View;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;


import androidx.appcompat.app.AppCompatActivity;

import org.json.JSONException;
import org.json.JSONObject;

import okhttp3.Call;
import okhttp3.Callback;
import okhttp3.MediaType;
import okhttp3.MultipartBody;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.RequestBody;
import okhttp3.Response;


import java.io.IOException;
import java.text.DateFormat;
import java.text.SimpleDateFormat;


public class Payment extends AppCompatActivity {

    public static final MediaType JSON = MediaType.parse("application/json; charset=utf-8");

    DataManager db;
    EditText card;
    EditText etCode;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        db = new DataManager(this);
        super.onCreate(savedInstanceState);
        db = new DataManager(this);
        setContentView(R.layout.activity_payment);
        TextView tv = (TextView)findViewById(R.id.toFrom);
        String to = getDate(MainActivity.c.timeStart);
        String from = getDate(MainActivity.c.timeEnd);
        tv.setText("Spot " + MainActivity.c.spot + " in Lot " + MainActivity.c.lot + "\nFrom:\n" + to + "\nTo:\n" + from+
                "\n\nPrice: $" + MainActivity.price );


        card = (EditText)findViewById(R.id.etCard);

        //Method from https://stackoverflow.com/questions/11790102/format-credit-card-in-edit-text-in-android
        //None of this function is mine
        //This function formats the user's input for their credit card so that it is automatically formatted like xxxx-xxxx-xxxx-xxxx
        card.addTextChangedListener(new TextWatcher() {

            private static final int TOTAL_SYMBOLS = 19; // size of pattern 0000-0000-0000-0000
            private static final int TOTAL_DIGITS = 16; // max numbers of digits in pattern: 0000 x 4
            private static final int DIVIDER_MODULO = 5; // means divider position is every 5th symbol beginning with 1
            private static final int DIVIDER_POSITION = DIVIDER_MODULO - 1; // means divider position is every 4th symbol beginning with 0
            private static final char DIVIDER = '-';

            @Override
            public void beforeTextChanged(CharSequence s, int start, int count, int after) {
                // noop
            }
            @Override
            public void onTextChanged(CharSequence s, int start, int before, int count) {
                // noop
            }

            @Override
            public void afterTextChanged(Editable s) {
                if (!isInputCorrect(s, TOTAL_SYMBOLS, DIVIDER_MODULO, DIVIDER)) {
                    s.replace(0, s.length(), buildCorrectString(getDigitArray(s, TOTAL_DIGITS), DIVIDER_POSITION, DIVIDER));
                }
            }

            private boolean isInputCorrect(Editable s, int totalSymbols, int dividerModulo, char divider) {
                boolean isCorrect = s.length() <= totalSymbols; // check size of entered string
                for (int i = 0; i < s.length(); i++) { // check that every element is right
                    if (i > 0 && (i + 1) % dividerModulo == 0) {
                        isCorrect &= divider == s.charAt(i);
                    } else {
                        isCorrect &= Character.isDigit(s.charAt(i));
                    }
                }
                return isCorrect;
            }

            private String buildCorrectString(char[] digits, int dividerPosition, char divider) {
                final StringBuilder formatted = new StringBuilder();

                for (int i = 0; i < digits.length; i++) {
                    if (digits[i] != 0) {
                        formatted.append(digits[i]);
                        if ((i > 0) && (i < (digits.length - 1)) && (((i + 1) % dividerPosition) == 0)) {
                            formatted.append(divider);
                        }
                    }
                }

                return formatted.toString();
            }

            private char[] getDigitArray(final Editable s, final int size) {
                char[] digits = new char[size];
                int index = 0;
                for (int i = 0; i < s.length() && index < size; i++) {
                    char current = s.charAt(i);
                    if (Character.isDigit(current)) {
                        digits[index] = current;
                        index++;
                    }
                }
                return digits;
            }
        });
    }



    public void finishedPay(View v)
    {
        etCode = (EditText)findViewById(R.id.etSecCode);
        
        String cc = card.getText().toString();
        String code = etCode.getText().toString();

        //Ensure card and code length are correct
        if(cc.length() == 19 && code.length() == 3) {
            addInfo();
            this.finish();
        }
        else
            Toast.makeText(this, "ERROR: Cannot process card information", Toast.LENGTH_SHORT).show();
    }

    public String getDate(long mills)
    {
        SimpleDateFormat formatter = new SimpleDateFormat("hh:mm MM/dd/yyyy");
        return formatter.format(mills);
    }



    public void addInfo()   { //Uses PHP script to add info to the database
        String url = "http://compsci02.snc.edu/cs460/2020/cadont/capstone/add.php";
        String json = createArray(); // gets JSON
        OkHttpClient client = new OkHttpClient();

        RequestBody body = RequestBody.create(JSON, json);

        Request request = new Request.Builder()
                .url(url)
                .post(body)
                .build();


        client.newCall(request).enqueue(new Callback() { // asynchronous, otherwise won't run
            @Override
            public void onFailure(Call call, IOException e) {
                e.printStackTrace();
                Log.i("PHP",e.toString());
            }

            @Override
            public void onResponse(Call call, final Response response) throws IOException {
              //  Log.i("PHP", response.toString());
            }
        });

        return;
    }


    public String createArray(){ // Converts all info into a json object that will be passed to PHP script
        String lot = Integer.toString(MainActivity.c.lot);
        String spot = Integer.toString(MainActivity.c.spot);
        String plate = MainActivity.c.plate;
        String timestart = Long.toString(MainActivity.c.timeStart);
        String timeend = Long.toString(MainActivity.c.timeEnd);
        JSONObject obj = new JSONObject();
        try {
            obj.put("lot", lot);
            obj.put("spot", spot);
            obj.put("plate", plate);
            obj.put("timestart", timestart);
            obj.put("timeend", timeend);

        } catch (JSONException e) {
            e.printStackTrace();
        }
        return obj.toString();
    }

}
