package com.example.parkingcapstone;

import androidx.appcompat.app.AppCompatActivity;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.EditText;
import android.widget.Toast;

import org.json.JSONArray;
import org.json.JSONException;

import java.io.IOException;

import okhttp3.Call;
import okhttp3.Callback;
import okhttp3.FormBody;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.RequestBody;
import okhttp3.Response;

public class PutPlate extends AppCompatActivity {

    JSONArray json;
    int jnum;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_put_plate);

        //Same thing as EnterTime.java
        //This prepares all lot/database information in preparation for the next activity
        String url = "http://compsci02.snc.edu/cs460/2020/cadont/capstone/read_from_db.php";
        OkHttpClient client = new OkHttpClient();

        Request request = new Request.Builder()
                .url(url)
                .build();

        client.newCall(request).enqueue(new Callback() { // asynchronous, otherwise won't run
            @Override
            public void onFailure(Call call, IOException e) {
                e.printStackTrace();
            }

            @Override
            public void onResponse(Call call, Response response) throws IOException {
                String myResponse = response.body().string(); // get what PHP echoed

                try {
                    json = new JSONArray(myResponse); // get JSONArray out of it
                    jnum = json.length();
                } catch (JSONException e) {
                } // try catch

                MainActivity.mainJson = json;
                MainActivity.mainJnum = jnum;
            } // onResponse
        }); //End call to PHP
    }

    public void showTime(View v)
    {
        EditText et = (EditText)findViewById(R.id.etLicensePlate);
        String plate = et.getText().toString();

        //Validate
        if(plate.isEmpty())
            Toast.makeText(this, "Please enter a license plate", Toast.LENGTH_SHORT).show();
        else {
            MainActivity.c.plate = plate;
            Intent intent = new Intent(this, ShowTime.class);
            startActivity(intent);
            this.finish();
        }
    }


}
