package com.example.parkingcapstone;

import androidx.appcompat.app.AppCompatActivity;

import android.content.Intent;
import android.icu.util.Calendar;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.TextView;
import android.widget.Toast;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.concurrent.TimeUnit;

public class ShowTime extends AppCompatActivity {

    JSONArray json;
    int jnum;
    DataManager db;
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_show_time);
        db = new DataManager(this);

        getTime(); //Searches through JSON array for a match in license plate, then displays the time remaining on that spot
    }

    public void home(View v)
    {
        this.finish();
    } //Back to home

    public void getTime()
    {
        json = new JSONArray();
        json = MainActivity.mainJson;
        jnum = MainActivity.mainJnum;
        JSONObject obj;
        String plate;
        String holdEnd;
        long mins = -1, hours, minutes;

        TextView tv = (TextView)findViewById(R.id.tvActualTime);
        Calendar calendar = Calendar.getInstance();
        long tEnd;

        for(int i = 0; i < jnum; i++) {
            try {
                obj = json.optJSONObject(i);
                plate = obj.getString("plate");
                if (plate.equals(MainActivity.c.plate)) {
                    holdEnd = obj.getString("timeend");
                    tEnd = Long.parseLong(holdEnd);
                    if(tEnd > calendar.getTimeInMillis()) //Ensures time remaining is positive
                    {
                        mins = tEnd - calendar.getTimeInMillis();
                    }
                }
            } catch (JSONException e) {
            }
        }

        // Did not find it
        if (mins == -1)
        {
            Toast.makeText(this, "ERROR: Unable to find plate, please try again", Toast.LENGTH_SHORT).show();
            Intent intent = new Intent(this, PutPlate.class);
            startActivity(intent);
            this.finish();
        }

        else {
            mins = TimeUnit.MILLISECONDS.toMinutes(mins);
            Log.i("ttt", "mins: " + mins);
            hours = mins / 60;
            minutes = mins % 60;
            Log.i("ttt", "hours: " + hours);
            Log.i("ttt", "minutes: " + String.format("%02d", minutes));
            tv.setText(hours + ":" + String.format("%02d", minutes));
        }

    }
}

