package com.example.parkingcapstone;

import androidx.appcompat.app.AppCompatActivity;
import androidx.core.view.ViewCompat;

import android.annotation.SuppressLint;
import android.app.ActionBar;
import android.content.Intent;
import android.database.Cursor;
import android.icu.util.Calendar;
import android.os.Bundle;
import android.os.Handler;
import android.os.Looper;
import android.util.Log;
import android.view.MotionEvent;
import android.view.View;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.Toast;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.IOException;

import okhttp3.Call;
import okhttp3.Callback;
import okhttp3.FormBody;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.RequestBody;
import okhttp3.Response;

public class ViewLot extends AppCompatActivity implements View.OnTouchListener{

    DataManager db;
    JSONArray json;
    int jnum = -1;

    // Represents all 10 spots in the parking lot
    int allSpots[] = new int[10];

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_view_lot);
        for(int i = 0; i < 10; i ++)
            allSpots[i] = 0;

        db = new DataManager(this);
        getSpots();
        putSpots();
    }





    @SuppressLint("ResourceType")
    public void putSpots()
    {
        RelativeLayout rl = (RelativeLayout) findViewById(R.id.Layout);
        ImageView iv0 = new ImageView(this);

        //Determines if this spot is open
        if(allSpots[0] == 0) {
            iv0.setImageDrawable(getDrawable(R.drawable.spotavailable)); // Spot available is universal
            iv0.setOnTouchListener(this);
        }
        else
            iv0.setImageDrawable(getDrawable(R.drawable.spottaken0)); // Each spot has it's own specified car, can be changed, spottaken 0-9

        RelativeLayout.LayoutParams lp0 = new RelativeLayout.LayoutParams(330,160);

        lp0.topMargin = 382;
        lp0.leftMargin = 45;
        iv0.setId(0); // Set image ID for easier spot selection
        rl.addView(iv0, lp0);

        //Repeat for all spots in the lot


        ImageView iv1 = new ImageView(this);
        if(allSpots[1] == 0) {
            iv1.setImageDrawable(getDrawable(R.drawable.spotavailable));
            iv1.setOnTouchListener(this);
        }
        else
            iv1.setImageDrawable(getDrawable(R.drawable.spottaken1));
        RelativeLayout.LayoutParams lp1 = new RelativeLayout.LayoutParams(330,160);

        lp1.topMargin = 600;
        lp1.leftMargin = 45;
        iv1.setId(1);
        rl.addView(iv1, lp1);


        ImageView iv2 = new ImageView(this);
        if(allSpots[2] == 0) {
            iv2.setImageDrawable(getDrawable(R.drawable.spotavailable));
            iv2.setOnTouchListener(this);
        }
        else
            iv2.setImageDrawable(getDrawable(R.drawable.spottaken2));
        RelativeLayout.LayoutParams lp2 = new RelativeLayout.LayoutParams(330,160);

        lp2.topMargin = 823;
        lp2.leftMargin = 45;
        iv2.setId(2);
        rl.addView(iv2, lp2);


        ImageView iv3 = new ImageView(this);
        if(allSpots[3] == 0) {
            iv3.setImageDrawable(getDrawable(R.drawable.spotavailable));
            iv3.setOnTouchListener(this);
        }
        else
            iv3.setImageDrawable(getDrawable(R.drawable.spottaken3));
        RelativeLayout.LayoutParams lp3 = new RelativeLayout.LayoutParams(330,160);

        lp3.topMargin = 1060;
        lp3.leftMargin = 45;
        iv3.setId(3);
        rl.addView(iv3, lp3);


        ImageView iv4= new ImageView(this);
        if(allSpots[4] == 0) {
            iv4.setImageDrawable(getDrawable(R.drawable.spotavailable));
            iv4.setOnTouchListener(this);
        }
        else
            iv4.setImageDrawable(getDrawable(R.drawable.spottaken4));
        RelativeLayout.LayoutParams lp4 = new RelativeLayout.LayoutParams(330,160);

        lp4.topMargin = 1315;
        lp4.leftMargin = 45;
        iv4.setId(4);
        rl.addView(iv4, lp4);



        ImageView iv5 = new ImageView(this);
        if(allSpots[5] == 0) {
            iv5.setImageDrawable(getDrawable(R.drawable.spotavailable));
            iv5.setOnTouchListener(this);
        }
        else
            iv5.setImageDrawable(getDrawable(R.drawable.spottaken5));
        RelativeLayout.LayoutParams lp5 = new RelativeLayout.LayoutParams(330,160);

        lp5.topMargin = 382;
        lp5.leftMargin = 700;
        iv5.setId(5);
        rl.addView(iv5, lp5);


        ImageView iv6 = new ImageView(this);
        if(allSpots[6] == 0) {
            iv6.setImageDrawable(getDrawable(R.drawable.spotavailable));
            iv6.setOnTouchListener(this);
        }
        else
            iv6.setImageDrawable(getDrawable(R.drawable.spottaken6));
        RelativeLayout.LayoutParams lp6 = new RelativeLayout.LayoutParams(330,160);

        lp6.topMargin = 600;
        lp6.leftMargin = 700;
        iv6.setId(6);
        rl.addView(iv6, lp6);


        ImageView iv7 = new ImageView(this);
        if(allSpots[7] == 0) {
            iv7.setImageDrawable(getDrawable(R.drawable.spotavailable));
            iv7.setOnTouchListener(this);
        }
        else
            iv7.setImageDrawable(getDrawable(R.drawable.spottaken7));
        RelativeLayout.LayoutParams lp7 = new RelativeLayout.LayoutParams(330,160);

        lp7.topMargin = 823;
        lp7.leftMargin = 700;
        iv7.setId(7);
        rl.addView(iv7, lp7);


        ImageView iv8 = new ImageView(this);
        if(allSpots[8] == 0) {
            iv8.setImageDrawable(getDrawable(R.drawable.spotavailable));
            iv8.setOnTouchListener(this);
        }
        else
            iv8.setImageDrawable(getDrawable(R.drawable.spottaken8));
        RelativeLayout.LayoutParams lp8 = new RelativeLayout.LayoutParams(330,160);

        lp8.topMargin = 1060;
        lp8.leftMargin = 700;
        iv8.setId(8);
        rl.addView(iv8, lp8);


        ImageView iv9 = new ImageView(this);
        if(allSpots[9] == 0) {
            iv9.setImageDrawable(getDrawable(R.drawable.spotavailable));
            iv9.setOnTouchListener(this);
        }
        else
            iv9.setImageDrawable(getDrawable(R.drawable.spottaken9));
        RelativeLayout.LayoutParams lp9 = new RelativeLayout.LayoutParams(330,160);

        lp9.topMargin = 1315;
        lp9.leftMargin = 700;
        iv9.setId(9);
        rl.addView(iv9, lp9);
    }
    
    public boolean onTouch(View v, MotionEvent event) {

        //Get ID of spot pressed
        MainActivity.c.spot = v.getId();

        Intent intent = new Intent(this, Payment.class);
        startActivity(intent);
        this.finish();
        return false;
    }

    @Override
    public void onBackPressed() {
        super.onBackPressed();

    }



    public void getSpots() {
        //Initialize all variables
        json = new JSONArray();
        json = MainActivity.mainJson; //Taken from previous activity, holds all information from the database
        jnum = MainActivity.mainJnum;
        JSONObject obj;
        String holdStart;
        String holdEnd;
        String lot;
        String spot;
        long tStart;
        long tEnd;

        for (int i = 0; i < jnum; i++) {
            try {
                obj = json.optJSONObject(i);// Convert to json object
                lot = obj.getString("lot"); //Get lot ID of element i

                if (lot.equals(Integer.toString(MainActivity.c.lot))) { // If user-selected lot and current db selection lot are the same
                    //Evaluate if this spot is taken
                    holdStart = obj.getString("timestart");
                    tStart = Long.parseLong(holdStart);

                    holdEnd = obj.getString("timeend");
                    tEnd = Long.parseLong(holdEnd);
                    if((MainActivity.c.timeStart > tStart && MainActivity.c.timeEnd < tEnd) // Time Requested is between the taken times
                            || (MainActivity.c.timeStart < tStart && MainActivity.c.timeEnd < tEnd && MainActivity.c.timeEnd > tStart) // Time requested starts before but ends during
                            || (MainActivity.c.timeStart > tStart && MainActivity.c.timeEnd > tEnd && MainActivity.c.timeStart < tEnd) // Time requested starts during
                            || (MainActivity.c.timeStart < tStart && MainActivity.c.timeEnd > tEnd)) // Time already taken is within the time requested
                    {
                        //One of the previous conditions were met, the current spot is not available
                        spot = obj.getString("spot");
                        int hold = Integer.parseInt(spot);
                        allSpots[hold] = 1; // sets it to taken
                    }

                }
            } catch (JSONException e) {

            }
        }
        return;
    }




}
